
;  rotary about arbitrary vector implemented by Maciej Guba,
;  macgub3@wp.pl , http://macgub.co.pl
;  ebx - normalized vector 3 dwords, each dword coefficient
;  esi - cosinus and sinus of angle
;  edi - desired matrix


make_arbitrary_mx:
 .nx      equ [ebx]
 .ny      equ dword[ebx+4]
 .nz      equ dword[ebx+8]
 .sinus   equ [esi]
 .cosinus equ dword[esi+4]

 fninit


 fld    dword[ebx]
 fmul   st,st0
 fld    st
 fchs
 fld1
 faddp
 fmul   .cosinus ; dword[esi]
 faddp
 fstp   dword[edi]

 fld    dword .nx
 fmul   .ny
 fld    .cosinus
 fchs
 fld1
 faddp
 fmulp
 fld    .nz ;dword[ebx+8]
 fmul   dword .sinus  ;dword[esi]
; fchs
 faddp
 fstp   dword[edi+4]

 fld    dword .nx
 fmul   .nz
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    .ny
 fmul   dword .sinus
 fchs
 faddp
 fstp   dword[edi+8]

 fld    dword .nx
 fmul   .ny
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    dword .sinus
 fmul   .nz
 fchs
 faddp
 fstp   dword[edi+12]

 fld    .ny
 fmul   st,st0
 fld    st
 fchs
 fld1
 faddp
 fmul   .cosinus
 faddp
 fstp   dword[edi+16]

 fld    .ny
 fmul   .nz
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    dword .sinus
 fmul   dword .nx
; fchs
 faddp
 fstp   dword[edi+20]



 fld    dword .nx
 fmul   .nz
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    .ny
 fmul   dword .sinus
; fchs
 faddp
 fstp   dword[edi+24]


 fld    .ny
 fmul   .nz
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    dword .nx
 fmul   dword .sinus
 fchs
 faddp
 fstp   dword[edi+28]




 fld    .nz
 fmul   st,st0
 fld    st
 fchs
 fld1
 faddp
 fmul  .cosinus
 faddp
 fstp  dword[edi+32]


ret
